// Copyright 2006 all rights reserved; see LICENSE file for BSD-style license

package edu.berkeley.sbp.bind;
import edu.berkeley.sbp.*;
import edu.berkeley.sbp.util.*;
import edu.berkeley.sbp.bind.*;
import java.io.*;
import java.util.*;
import java.lang.reflect.*;

public class BindingFunctor<T> implements TreeFunctor<T,Object>, ToJava {
    private Binding _binding;
    private String _toString;
    public String toString() {
        return _toString;
    }
    public BindingFunctor(String toString, Binding binding) {
        this._binding = binding;
        this._toString = toString;
    }
    public void toJava(StringBuffer sb) {
        sb.append("new BindingFunctor(");
        sb.append("\"");
        sb.append(StringUtil.toJavaString(_toString));
        sb.append("\", ");
        _binding.toJava(sb);
        sb.append(")");
    }
    public Object invoke(Iterable<Tree<T>> t) {
        ArrayList ret = new ArrayList();
        for(Tree tc : t) {
            if (tc.head() != null && tc.head() instanceof Functor)
                ret.add(((TreeFunctor<Object,Object>)tc.head()).invoke(tc.children()));
            else if (tc.size() == 0)
                ret.add(tc.head());
            else {
                System.err.println("FIXME: don't know what to do about " + tc);
                ret.add(null);
            }
        }
        Object[] o = (Object[])ret.toArray(new Object[0]);
        return _binding.invoke(o);
    }
}
